;for AKI-80 GOLD RSLOSAD.AS
;X'tal19.6608MHzgp
;SIOBgp

PIOA::         =$1C
PIOB::         =$1E
SIOA::         =$18
SIOB::         =$1A
CTC0::         =$10
CTC1::         =$11
CTC2::         =$12
CTC3::         =$13
TIMEC::        =$04
GO::           =$8000

               ===-->START
PIOAI::        \CF
               \FF
PAEND::         

PIOBI::        \CF
               \00
PBEND::

SIOACD::       \18
               \04
               \44

               \03
               \C1
               \05
               \6A
SAEND::

SIOBCD::       \18
               \04
               \44

               \03
               \C1
               \05
               \6A
SBEND::

CTC0CD::       \17
               \04                  ;19.6608MHz
C0END::

CTC2CD::       \17
               \04                  ;19.6608MHz
C2END::

CTC3CD::       \17
               \04
C3END::

               
               ;---IM1---
               ORG 0038h
               INTs
               RETI
               ;---NMI---
               ORG$0066
               RETN
               
               ;---START---
               ORG$0100
START::        INTs
               A<$0
               I<A
               SP<$0
               
               HL<$8000
WAIT:          HL-1
               A<H
               AVL>A
               Z=0->WAIT
               IOSET

               
               ;---main test----
LOOP1:         RSIN
               A-$00
               Z=1->LOOP1
               A-$FF
               Z=0->ERR
               ;---DATA COUNT---
               RSIN
               D<A
               RSIN
               E<A
               ;---DATA STORE---
               HL<GO
LOOP2:         RSIN
               (HL)<A
               ;---MONITOR---
               ;OUT(PIOB)<A
               ;B<A
               ;RSOUT
               ;
               HL+1
               DE-1
               A<D
               AVE>A
               Z=0->LOOP2
               ;---LOAD PROGRAM START---
               B<$4F      ;"O"
               RSOUT
               ===-->GO

END:           ===->END

ERR:           B<$45      ;"E"
               RSOUT
               ===->END
               
SUB RSOUT
LOOP1:         A<$10
               OUT(SIOB+1)<A
               IN_A<(SIOB+1)
               A^$24>A
               A-$20
               Z=1->LOOP1
               
               A<B
               OUT(SIOB)<A
               RET
               
SUB RSIN
LOOP1:         A<$10
               OUT(SIOB+1)<A
               IN_A<(SIOB+1)
               A^$21>A
               A-$20
               Z=1->LOOP1

               IN_A<(SIOB)
               RET

;---I/OZbgAbv---
SUB IOSET
               HL<PIOAI
               B<PAEND-PIOAI
               C<PIOA+1
               OUT(+A)

               HL<PIOBI
               B<PBEND-PIOBI
               C<PIOB+1
               OUT(+A)

               HL<CTC0CD
               B<C0END-CTC0CD
               C<CTC0
               OUT(+A)

               HL<CTC2CD
               B<C2END-CTC2CD
               C<CTC2
               OUT(+A)
               
               HL<CTC3CD
               B<C3END-CTC3CD
               C<CTC3
               OUT(+A)

               HL<SIOACD
               B<SAEND-SIOACD
               C<SIOA+1
               OUT(+A)

               HL<SIOBCD
               B<SBEND-SIOBCD
               C<SIOB+1
               OUT(+A)

               RET
